//package agents;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Random;

import negotiator.Agent;
import negotiator.Bid;
import negotiator.actions.Accept;
import negotiator.actions.Action;
import negotiator.actions.Offer;
import negotiator.issue.Issue;
import negotiator.issue.IssueDiscrete;
import negotiator.issue.IssueInteger;
import negotiator.issue.IssueReal;
import negotiator.issue.Value;
import negotiator.issue.ValueInteger;
import negotiator.issue.ValueReal;


/**
 * @author W.Pasman
 * Some improvements over the standard SimpleAgent.
 */
public class AgentNS extends Agent
{
	private Action actionOfPartner=null;
	private static double MINIMUM_BID_UTILITY = 0.5;
	private static double FIRST_BID_UTILITY=0.8;
	int i=1;
	int j=0;
	int max=0;
	double [] bef_util=new double [200];
	double [] aft_util=new double [200];
	Bid [] bid_util=new Bid [200];
	Bid getbid=null;
	Bid nicebid=null;
	double utility=0;
	double firsttime=0;
	int countacc=0;
	int countoff=0;
	Bid nextBid=null;
	double ptime=0;
	int m=0;
	int next;
	int nnext;
	int nnnext;
	double discountFactor=1.0;
	
	double [] util_acc=new double[30];
	int k=0;

	/**
	 * init is called when a next session starts with the same opponent.
	 */
	public void init()
	{
		if(utilitySpace.getReservationValue() != null)
		{	
			MINIMUM_BID_UTILITY = utilitySpace.getReservationValue();
	
		}
        
		try 
		    {
			this.discountFactor=utilitySpace.getDiscountFactor();
			if (discountFactor==0.0){
				discountFactor=1;
			}
	
	  }
      catch(Exception ex) {
			//System.out.println("error when seeting DF");
		
      }
    
        
        
	}

	public static String getVersion() { return "1.2"; }

	public void ReceiveMessage(Action opponentAction) 
	{
		actionOfPartner = opponentAction;
	}


	public Action chooseAction()
	{
		Action action = null;
		double RTime=timeline.getTime();
	try 
		{ 
			if(actionOfPartner==null){
				action = chooseRandomBidAction();
				double firstutil=getUtility(nextBid)/Math.pow(discountFactor,RTime);
				bef_util[0]=firstutil;
				aft_util[0]=bef_util[0];
				utility=firstutil;
				bid_util[0]=nextBid;
				action = new Offer(getAgentID(),bid_util[0]);
			}
			
			if(actionOfPartner instanceof Offer)
				//Offer ̎͑肪loƂɑ΂ĉactionNȂ΂ȂȂ.
			{
                double off_utility=utility;
				countacc++;
				//System.out.println("Partner-Offer roop Count***"+countacc);
				//[vĂ񐔂JEg
				//System.out.println("#####Partner-offer####################################");
				Bid partnerBid = ((Offer)actionOfPartner).getBid();
				double offeredutil = getUtility(partnerBid)/Math.pow(discountFactor,RTime);
				//System.out.println(offeredutil);
				util_acc[k]=offeredutil;
				
				//System.out.println("util_acc***"+util_acc[k]);
				
				// get current time
				double time = timeline.getTime();
				double P=Paccept(offeredutil,time);
				/*
				if (P>Math.random()) 
					action = new Accept(getAgentID());
				*/
				
				//System.out.println("#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%");
			//System.out.println("util_acc"+util_acc[k]);
			//System.out.println("utility"+off_utility);
			//System.out.println("#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%#%");

				if(util_acc[k]>off_utility && off_utility!=0.0 && time >0.01 && time< 0.98){
					if(P>Math.random()){
						//System.out.println("acceptl");
					action = new Accept(getAgentID());}
				k++;
				}else if(util_acc[k]<off_utility && off_utility!=0.0 && time>0.98){
					//System.out.println("acceptll");
					action = new Accept(getAgentID());
				}
				else{
					
					countoff++;
					//System.out.println("%%%Parner-Not offer%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%");
					//Accept  ͎̎lBidKv
					getbid=getRandomBid();
					bid_util[i]=getbid;
					double myutil = getUtility(getbid)/Math.pow(discountFactor,RTime);
					double time1 = timeline.getTime();
					
					bef_util[i]=myutil;
					aft_util[i]=bef_util[i];
					i++;
					//chooseActionNX邱Ƃɂbef_utilɂǂǂmyutillo͂Ă
					//̒lsortāA傫̂plƂďo͂Kv
					//bef_util̒l̂܂aft_utilɃRs[
					//Rs[lsort邱Ƃō~ɕѕς邱Ƃł
					
					bubbleSort(aft_util,false);
					//aft_util̒l~ɕѕςꂽ
					for(int a=0;a<i;a++){
						if(aft_util[a]==aft_util[a+1]) aft_util[a]=0;
						}
					bubbleSort(aft_util,false);
					
					
					//System.out.println("*-----------------------------------------------*");
					for(int a=0;a<i;a++){
						//System.out.println("before_sort:"+bef_util[a]);
					}
					//System.out.println("- - - - - - - - - - - - - - - - - -");
					for(int b=0;b<i;b++){
						
						//System.out.println("after_sort:"+aft_util[b]);
						}
					//System.out.println("*-----------------------------------------------*");
					utility=aft_util[max];
					//aft_util[0]Ɋi[Ălԑ傫̂̂͂
					//utilityƂē͂				
					//System.out.println("utility:    "+utility);
					
					for(int k=0;k<i;k++){
						if(bef_util[k]==utility)
							j=k;
						}
					//System.out.println(j);
					//̃[vƂj̒l͌plƂBid̔zɓ͂邱Ƃł
					//ɂĂBidl߂邱Ƃł	
					nicebid=bid_util[j];
					//System.out.println(nicebid+"AND J is"+j);
					
int x=1;
int z=1;
double y=0.1;
double tr_utility=utility;
while( x<50 && time1<1 && utility == aft_util[0] ){
	if(
			/*countacc>=(10*x)+40 && 40+(10*(x+1))>countacc
			 */
			time1 >=(z*0.1)
			 
			){
		//utility̒lȂ
		utility=aft_util[x];
		/*
		while(tr_utility<utility){
			//O̒l̕ȂႢȂ
			//O̒l̕炱̃[vʂȂႾ
			x++;
			utility=aft_util[x];
		}
		*/
		
		if(utility<0.1){
			utility=aft_util[x-1];
			x--;
		}
		
		
		if(time1>=0.9)action = new Accept(getAgentID());
		//System.out.println("++++++++++++++++++");
	
		/*
		while(time1>y && (0.1+y)<time1){
			utility=utility-y;
			y++;
		}
		*/
	}
	x++;
	
}


//System.out.println("TIME***"+time1);
if(utility != aft_util[0])	
	{
	//System.out.println("time after utility"+utility);
for(int k=0;k<i;k++){
	if(bef_util[k]==utility)
		j=k;
	}
nicebid=bid_util[j];
//System.out.println(nicebid);
	}

//int l;

//System.out.println(bid_util[0]);
for(int l=0;l<i;l++){

	 if(utility!=aft_util[0]){
			if(bef_util[l]==aft_util[m+1] && time1>0 && time1<=0.4){
				next=l;
			nicebid=bid_util[l];
			//System.out.println(nicebid);
			}
			else	if(bef_util[l]==aft_util[m+2] && time1>0.4 && time1<=0.8){
				nnext=l;
			nicebid=bid_util[l];
			//System.out.println(nicebid);
			}
			else 	if(bef_util[l]==aft_util[m+3] && time1>0.8 && time1<=0.99){
				nnnext=l;
			nicebid=bid_util[l];
			//System.out.println(nicebid);
		}
		}
}

//System.out.println(nicebid);

action=new Offer(getAgentID(),nicebid);
/*
if( time1<0.3) action = new Offer(getAgentID(),nicebid);
else if(time1>=0.3 && time1<=0.5) action=new Offer(getAgentID(),bid_util[next]);
else		if(time1>0.5 && time1<=0.8) action=new Offer(getAgentID(),bid_util[nnext]);
else 		if(time1>0.8 && time1 <1) action=new Offer(getAgentID(),bid_util[nnnext]);
*/
				
}
				}

	} catch (Exception e) 
	
	
	{ 
	
		action=new Offer(getAgentID(),nicebid);		
			/*
			System.out.println("----------catch---------");
			System.out.println("Exception in ChooseAction:"+e.getMessage());
			action=new Accept(getAgentID()); // best guess if things go wrong. 
*/	}
		
		return action;
	}

	/**
	 * Wrapper for getRandomBid, for convenience.
	 * @return new Action(Bid(..)), with bid utility > MINIMUM_BID_UTIL.
	 * If a problem occurs, it returns an Accept() action.
	 */
	private Action chooseRandomBidAction() 
	{

		try { nextBid = getRandomBid(); }
		catch (Exception e) { 
			
			//System.out.println("Problem with received bid:"+e.getMessage()+". cancelling bidding");
		
		}
		if (nextBid == null) return (new Accept(getAgentID()));                
		return (new Offer(getAgentID(), nextBid));
	}

	/**
	 * @return a random bid with high enough utility value.
	 * @throws Exception if we can't compute the utility (eg no evaluators have been set)
	 * or when other evaluators than a DiscreteEvaluator are present in the util space.
	 */
	private Bid getRandomBid() throws Exception
	{
		HashMap<Integer, Value> values = new HashMap<Integer, Value>(); // pairs <issuenumber,chosen value string>
		ArrayList<Issue> issues=utilitySpace.getDomain().getIssues();
		Random randomnr= new Random();

		// create a random bid with utility>MINIMUM_BID_UTIL.
		// note that this may never succeed if you set MINIMUM too high!!!
		// in that case we will search for a bid till the time is up (2 minutes)
		// but this is just a simple agent.
		Bid bid=null;
		do 
		{
			for(Issue lIssue:issues) 
			{
				switch(lIssue.getType()) {
				case DISCRETE:
					IssueDiscrete lIssueDiscrete = (IssueDiscrete)lIssue;
					int optionIndex=randomnr.nextInt(lIssueDiscrete.getNumberOfValues());
					values.put(lIssue.getNumber(), lIssueDiscrete.getValue(optionIndex));
					break;
				case REAL:
					IssueReal lIssueReal = (IssueReal)lIssue;
					int optionInd = randomnr.nextInt(lIssueReal.getNumberOfDiscretizationSteps()-1);
					values.put(lIssueReal.getNumber(), new ValueReal(lIssueReal.getLowerBound() + (lIssueReal.getUpperBound()-lIssueReal.getLowerBound())*(double)(optionInd)/(double)(lIssueReal.getNumberOfDiscretizationSteps())));
					break;
				case INTEGER:
					IssueInteger lIssueInteger = (IssueInteger)lIssue;
					int optionIndex2 = lIssueInteger.getLowerBound() + randomnr.nextInt(lIssueInteger.getUpperBound()-lIssueInteger.getLowerBound());
					values.put(lIssueInteger.getNumber(), new ValueInteger(optionIndex2));
					break;
				default: throw new Exception("issue type "+lIssue.getType()+" not supported by SimpleAgent2");
				}
			}
			bid=new Bid(utilitySpace.getDomain(),values);
		} while ((getUtility(bid)/Math.pow(discountFactor,timeline.getTime())) < FIRST_BID_UTILITY);
		//0.8傫lgetUtilityƂȂƃ[vo邱ƂłȂ

		return bid;
	}

	/**
	 * This function determines the accept probability for an offer.
	 * At t=0 it will prefer high-utility offers.
	 * As t gets closer to 1, it will accept lower utility offers with increasing probability.
	 * it will never accept offers with utility 0.
	 * @param u is the utility 
	 * @param t is the time as fraction of the total available time 
	 * (t=0 at start, and t=1 at end time)
	 * @return the probability of an accept at time t
	 * @throws Exception if you use wrong values for u or t.
	 * 
	 */
	double Paccept(double u, double t1) throws Exception
	{
		double t=t1*t1*t1; // steeper increase when deadline approaches.
		if (u<0 || u>1.05) throw new Exception("utility "+u+" outside [0,1]");
		// normalization may be slightly off, therefore we have a broad boundary up to 1.05
		if (t<0 || t>1) throw new Exception("time "+t+" outside [0,1]");
		if (u>1.) u=1;
		if (t==0.5) return u;
		return (u - 2.*u*t + 2.*(-1. + t + Math.sqrt(sq(-1. + t) + u*(-1. + 2*t))))/(-1. + 2*t);
	}

	double sq(double x) { return x*x; }
	
//------------sort̂ɗp---------------------------------------
	
    private static double[] bubbleSort(double[] x, boolean asc) {  
        for (int i = 0; i < x.length; i++) {// 0, 1, ... len  
            for (int j = i + 1; j < x.length; j++) {// i+1, ... len  
                    if (!asc && x[i] < x[j]) {    //~̏ꍇ  
                    swapValue(x, i, j);  
                }  
            }  
        }  
          
        return x;  
    }  
    private static void swapValue(double[] x, int i, int j) {  
        double tmp = x[i];
        x[i] = x[j];      
        x[j] = tmp;      
    }  
	
}